/**
 * 求和
 */
sum = function (range) {
    var sumNum = 0;
    var row = range.length;
    for (var r = 0; r < row; r++) {
        var col = range[r].length;
        for (var c = 0; c < col; c++) {
            if (range[r][c] && range[r][c].v) {
                if (isNumber(range[r][c].v)) {
                    sumNum = sumNum + parseFloat(range[r][c].v);
                }
            }
        }
    }
    return sumNum;
}

/**
 * 求平均数
 */
average = function (range) {
    var sumNum = 0;
    var count = 0;
    var row = range.length;
    for (var r = 0; r < row; r++) {
        var col = range[r].length;
        for (var c = 0; c < col; c++) {
            if (range[r][c] && range[r][c].v) {
                if (isNumber(range[r][c].v)) {
                    count++;
                    sumNum = sumNum + parseFloat(range[r][c].v);
                }
            }
        }
    }
    if (count > 0) {
        return sumNum / count;
    } else {
        return sumNum;
    }
}

/**
 * 计数
 */
count = function (range) {
    var count = 0;
    var row = range.length;
    for (var r = 0; r < row; r++) {
        var col = range[r].length;
        for (var c = 0; c < col; c++) {
            if (range[r][c] && range[r][c].v) {
                if (isNumber(range[r][c].v)) {
                    count++;
                }
            }
        }
    }
    return count;
}

/**
 * 最大值
 */
max = function (range) {
    var max = 0;
    var row = range.length;
    for (var r = 0; r < row; r++) {
        var col = range[r].length;
        for (var c = 0; c < col; c++) {
            if (range[r][c] && range[r][c].v) {
                if (isNumber(range[r][c].v)) {
                    if (parseFloat(range[r][c].v) > max) {
                        max = parseFloat(range[r][c].v);
                    }
                }
            }
        }
    }
    return max;
}

/**
 * 最小值
 */
min = function (range) {
    var MAX = Math.pow(2, 36);
    var min = MAX;
    var row = range.length;
    for (var r = 0; r < row; r++) {
        var col = range[r].length;
        for (var c = 0; c < col; c++) {
            if (range[r][c] && range[r][c].v) {
                if (isNumber(range[r][c].v)) {
                    if (parseFloat(range[r][c].v) < min) {
                        min = parseFloat(range[r][c].v);
                    }
                }
            }
        }
    }
    return min === MAX ? 0 : min;
}

var formulaTags = {
    "SUM": sum,
    "AVERAGE": average,
    "COUNT": count,
    "MAX": max,
    "MIN": min,
};

var letterToNums = {
    "A": 1,
    "B": 2,
    "C": 3,
    "D": 4,
    "E": 5,
    "F": 6,
    "G": 7,
    "H": 8,
    "I": 9,
    "J": 10,
    "K": 11,
    "L": 12,
    "M": 13,
    "N": 14,
    "O": 15,
    "P": 16,
    "Q": 17,
    "R": 18,
    "S": 19,
    "T": 20,
    "U": 21,
    "V": 22,
    "W": 23,
    "X": 24,
    "Y": 25,
    "Z": 26
};

letterToNum = function (letter) {
    var letters = letter.split("");
    var num = 0;
    var len = letters.length;
    for (var i = 0; i < len; i++) {
        var lNum = letterToNums[letters[i]];
        var powNum = Math.pow(26, (len - i - 1));
        num = num + lNum * powNum;
    }
    return num;
}

/**
 * 判断是否是浮点数
 */
isNumber = function (val) {
    var regPos = /^\d+(\.\d+)?$/; //非负浮点数
    var regNeg = /^(-(([0-9]+\.[0-9]*[1-9][0-9]*)|([0-9]*[1-9][0-9]*\.[0-9]+)|([0-9]*[1-9][0-9]*)))$/; //负浮点数
    if (regPos.test(val) || regNeg.test(val)) {
        return true;
    } else {
        return false;
    }
}
